/*************************************************************************
 * Structures:															 *								
 *************************************************************************/

//overhead map sprite controls
struct SN {
	u32 objNumber;	// number of the object in OAM
	u8 x;			// x-coordinate
	u8 y;			// y-coordinate
	u8 new_x;		// new x
	u8 new_y;		// new y
	u8 offsetl;		// left offset
	u8 offsetu;		// upward offset
	u8 offsetd;		// downward offset
	u8 offsetr;		// right offset
	u8 mvt;			// movement
	u8 dir;			// direction of above movement
	u8 new_dir;		// new facing
	u8 framecnt;	// number of frames
	u8 animcnt;		// number of animations
};

//overhead version of the server ninja
struct SN Josh;

//Side-scroll version of the server ninja
struct SSSN SSJosh;

//side-scroll map sprite control
struct SSSN {
	u32 objNumber1;	// number of the object in OAM
	u32 objNumber2;	// number of the object in OAM
	u32 objNumber3;	// number of the object in OAM
	u8 x;			// x-coordinate
	u8 y;			// y-coordinate
	u8 new_x;		// new x
	u8 new_y;		// new y
	u8 offsetl;		// left offset
	u8 offsetu;		// upward offset
	u8 offsetd;		// downward offset
	u8 offsetr;		// right offset
	u8 mvt;			// moving or not
	u8 attackA;		// attacking with A button or not
	u8 attackB;		// attacking with B button or not
	u8 swapL;		// hit the L button to switch weapons
	u8 swapR;		// hit the R button to switch weapons
	u8 dir;			// direction of above movement
	u8 new_dir;		// new facing
	u8 framecnt;	// number of frames
	u8 animcnt;		// number of animations
	u8 A_weapon;	// weapon associated with A button
	u8 B_weapon;	// weapon associated with B button
	u8 AObj;		// object number associated the the A button weapon
	u8 BObj;		// object number associated the the B button weapon
};

/*********************************************************************************
 * Overhead map
 ********************************************************************************/
void overhead() {

	// background palatte
	ham_LoadBGPal(&overheadmap_Palette, 256);
	// Setup the array spot
	array_spot = (1024 * Josh.dir) + (256 * Josh.animcnt);

	// Setup Josh
	if (bandanna_color == RED_BANDANNA) {
		Josh.objNumber = ham_CreateObj((void *)&sprite_SNData[array_spot],2,2,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,Josh.x,Josh.y);
	} else if (bandanna_color == BLACK_BANDANNA) {
		Josh.objNumber = ham_CreateObj((void *)&sprite_SN2Data[array_spot],2,2,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,Josh.x,Josh.y);
	} else {	// bandanna_color == BLUE_BANDANNA
		Josh.objNumber = ham_CreateObj((void *)&sprite_SN3Data[array_spot],2,2,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,Josh.x,Josh.y);
	}
	timerObj = ham_CreateObj((void *)&office_healthData[0+((int)ceil(30-30*s_tim0/100))*128],1,1,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,(int)(7.5*16),0);
	serverObj = ham_CreateObj((void *)&useful_textData[256],1,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,(int)(7.5*16),4);
	
	next_level_marker(); // Mark the entrance to the next level

	srand(time(NULL));

	ham_StartIntHandler(INT_TYPE_VBL,&vblFunc);
	while ((living == 1) && (won == 0) && (fight == 0) && (timeflag == 0)) {
		query_keys();
	}
	ham_StopIntHandler(INT_TYPE_VBL);

	clean_overhead();


	if ((living == 1) && (timeflag == 0) && (won == 0)) {
		if (next_level < 8) {

			SideScroll();
		} 
		else {
			
			BossBattle();
		}
	}

}

/*********************************************************************************
 * Side Scroller Map
 ********************************************************************************/
void SideScroll() {
	map_fragment_info_ptr mymap;
	ham_InitBg(1,0,1,0); // turn off the overhead map
	ham_ResetObj();
	SNinit_SS();
	krapStop();
	fightclubsound();
	enemy_health = 90 + (next_level * 10);
	enemy_dead = 0;

	// background palette - same steps as in overheadmap()
	if (next_level == 1) {
		ham_LoadBGPal(&side_scroll1_Palette, 256);
		ham_bg[0].ti = ham_InitTileSet(&side_scroll1_Tiles, SIZEOF_16BIT(side_scroll1_Tiles),1,1);
		ham_bg[0].mi = ham_InitMapEmptySet(3,0);
		mymap = ham_InitMapFragment(&side_scroll1_Map,30,20,0,0,30,20,0);
		ham_InsertMapFragment(mymap,0,0,0);
		ham_InitBg(0,1,0,0);
	} else if (next_level == 2) {
		ham_LoadBGPal(&side_scroll2_Palette, 256);
		ham_bg[0].ti = ham_InitTileSet(&side_scroll2_Tiles, SIZEOF_16BIT(side_scroll2_Tiles),1,1);
		ham_bg[0].mi = ham_InitMapEmptySet(3,0);
		mymap = ham_InitMapFragment(&side_scroll2_Map,30,20,0,0,30,20,0);
		ham_InsertMapFragment(mymap,0,0,0);
		ham_InitBg(0,1,0,0);
	} else if (next_level == 3) {
		ham_LoadBGPal(&side_scroll3_Palette, 256);
		ham_bg[0].ti = ham_InitTileSet(&side_scroll3_Tiles, SIZEOF_16BIT(side_scroll3_Tiles),1,1);
		ham_bg[0].mi = ham_InitMapEmptySet(3,0);
		mymap = ham_InitMapFragment(&side_scroll3_Map,30,20,0,0,30,20,0);
		ham_InsertMapFragment(mymap,0,0,0);
		ham_InitBg(0,1,0,0);
	} else if (next_level == 4) {
		ham_LoadBGPal(&side_scroll4_Palette, 256);
		ham_bg[0].ti = ham_InitTileSet(&side_scroll4_Tiles, SIZEOF_16BIT(side_scroll4_Tiles),1,1);
		ham_bg[0].mi = ham_InitMapEmptySet(3,0);
		mymap = ham_InitMapFragment(&side_scroll4_Map,30,20,0,0,30,20,0);
		ham_InsertMapFragment(mymap,0,0,0);
		ham_InitBg(0,1,0,0);
	} else if (next_level == 5) {
		ham_LoadBGPal(&side_scroll5_Palette, 256);
		ham_bg[0].ti = ham_InitTileSet(&side_scroll5_Tiles, SIZEOF_16BIT(side_scroll5_Tiles),1,1);
		ham_bg[0].mi = ham_InitMapEmptySet(3,0);
		mymap = ham_InitMapFragment(&side_scroll5_Map,30,20,0,0,30,20,0);
		ham_InsertMapFragment(mymap,0,0,0);
		ham_InitBg(0,1,0,0);
	} else if (next_level == 6) {
		ham_LoadBGPal(&side_scroll6_Palette, 256);
		ham_bg[0].ti = ham_InitTileSet(&side_scroll6_Tiles, SIZEOF_16BIT(side_scroll6_Tiles),1,1);
		ham_bg[0].mi = ham_InitMapEmptySet(3,0);
		mymap = ham_InitMapFragment(&side_scroll6_Map,30,20,0,0,30,20,0);
		ham_InsertMapFragment(mymap,0,0,0);
		ham_InitBg(0,1,0,0);
	} else if (next_level == 7) {
		ham_LoadBGPal(&side_scroll7_Palette, 256);
		ham_bg[0].ti = ham_InitTileSet(&side_scroll7_Tiles, SIZEOF_16BIT(side_scroll7_Tiles),1,1);
		ham_bg[0].mi = ham_InitMapEmptySet(3,0);
		mymap = ham_InitMapFragment(&side_scroll7_Map,30,20,0,0,30,20,0);
		ham_InsertMapFragment(mymap,0,0,0);
		ham_InitBg(0,1,0,0);
	}

	// Set-up other dimensional version of Josh
	if (bandanna_color == RED_BANDANNA) {
		SSJosh.objNumber2 = ham_CreateObj((void *)&SS_SNData[ssarray_spot+0],2,3,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,SSJosh.x,SSJosh.y);
		SSJosh.objNumber3 = ham_CreateObj((void *)&SS_SNData[ssarray_spot+1024],0,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,SSJosh.x,SSJosh.y+64);
	} else if (bandanna_color == BLACK_BANDANNA) {
		SSJosh.objNumber2 = ham_CreateObj((void *)&SS_SN2Data[ssarray_spot+0],2,3,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,SSJosh.x,SSJosh.y);
		SSJosh.objNumber3 = ham_CreateObj((void *)&SS_SN2Data[ssarray_spot+1024],0,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,SSJosh.x,SSJosh.y+64);
	} else {	// bandanna_color == BLUE_BANDANNA
		SSJosh.objNumber2 = ham_CreateObj((void *)&SS_SN3Data[ssarray_spot+0],2,3,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,SSJosh.x,SSJosh.y);
		SSJosh.objNumber3 = ham_CreateObj((void *)&SS_SN3Data[ssarray_spot+1024],0,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,SSJosh.x,SSJosh.y+64);
	}
	SSJosh.AObj = ham_CreateObj((void *)&A_weaponsData[0+(SSJosh.A_weapon-1)*32],0,0,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,0,9*16);
	SSJosh.BObj = ham_CreateObj((void *)&B_weaponsData[0+(SSJosh.B_weapon-5)*32],0,0,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,14*16,9*16);
	officeObj = ham_CreateObj((void *)&office_healthData[0+((int)ceil(30-30.0*enemy_health/(90+(next_level*10))))*128],1,1,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,(int)(6.5*16),9*16+4);
	enemyObj = ham_CreateObj((void *)&useful_textData[256*2],1,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,(int)(4.5*16),9*16);
	AObj = ham_CreateObj((void *)&useful_textData[0],0,1,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,(int)(0.5*16),9*16);
	BObj = ham_CreateObj((void *)&useful_textData[128],0,1,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,13*16,9*16);
	timerObj = ham_CreateObj((void *)&office_healthData[0+((int)ceil(30-30*s_tim0/100))*128],1,1,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,(int)(7.5*16),0);
	serverObj = ham_CreateObj((void *)&useful_textData[256],1,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,(int)(7.5*16),4);
	
	ham_StartIntHandler(INT_TYPE_VBL,&ssvblFunc);

	while ((enemy_dead == 0) && (timeflag == 0)) {

		query_keys_ss();
	}
	krapStop();
	ham_StopIntHandler(INT_TYPE_VBL);

	clean_SS();	
}

/*********************************************************************************
 * Boss Battle Map
 ********************************************************************************/
void BossBattle() {
    
	M_TIM3CNT_TIMER_STOP
	krapStop();
	map_fragment_info_ptr mymap;
	ham_DeInitBg(1); // turn off the overhead map
	ham_ResetObj();
	ham_SetBgMode(1);
	
	ham_LoadBGPal(&boss_back_Palette, 256);
	ham_bg[0].ti = ham_InitTileSet(&boss_back_Tiles, SIZEOF_16BIT(boss_back_Tiles),1,1);
	ham_bg[0].mi = ham_InitMapEmptySet(3,0);
	mymap = ham_InitMapFragment(&boss_back_Map,30,20,0,0,30,20,0);
	ham_InsertMapFragment(mymap,0,0,0);
	ham_InitBg(0,1,1,0);

	boss_balloon = ham_CreateObj((void *)&boss_talkData[boss_spot * 2048],0,3,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,156,0);
	choicewin1 = ham_CreateObj((void *)&full_responseData[(response_spot * 3072)],1,3,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,24,127);
	choicewin2 = ham_CreateObj((void *)&full_responseData[(response_spot * 3072) + 1024],1,3,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,88,127);
	choicewin3 = ham_CreateObj((void *)&full_responseData[(response_spot * 3072) + 2048],1,3,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,152,127);
	selectObj = ham_CreateObj((void *)&AData[0],0,0,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,24,129);

	ham_StartIntHandler(INT_TYPE_VBL,&bbvblFunc);

	while ((won == 0) && (living == 1)) {
		query_keys_bb();
	}
	
	clean_BB();

	ham_StopIntHandler(INT_TYPE_VBL);
}

/*******************************************************************
 * Server Ninja sprite inialization under overhead map mode
 ******************************************************************/
void SNinit() {
	ham_LoadBGPal(&overheadmap_Palette, 256);

	map_fragment_info_ptr mymap;

	// SN palatte
	ham_LoadObjPal(&sprite_SNPalette, 256);
	// initialize ServerNinja
	Josh.dir = ANIM_DOWN;
	Josh.framecnt = 0;
	Josh.animcnt = 0;
	Josh.x = 16;
	Josh.y = 16;
	Josh.new_x = 16;
	Josh.new_y = 16;
	Josh.offsetl = 4;
	Josh.offsetu = 18;
	Josh.offsetd = 28;
	Josh.offsetr = 12;
	Josh.mvt = 0;

	// Initialize the overhead background
	ham_bg[1].ti = ham_InitTileSet(&overheadmap_Tiles, SIZEOF_16BIT(overheadmap_Tiles),1,1);
	// Initialize an empty map
	ham_bg[1].mi = ham_InitMapEmptySet(3,0);
	// Make a reference of the map data in the ROM
	mymap = ham_InitMapFragment(&overheadmap_Map,30,20,0,0,30,20,0);
	// copy map to BG1 at x=y=0
	ham_InsertMapFragment(mymap,1,0,0);
	// display the background
	ham_InitBg(1,1,1,0);
}

/*********************************************************************************
 * Interrupt Function for Server Ninja sprite under overhead map mode
 ********************************************************************************/
void vblFunc() {
	ham_CopyObjToOAM(); // copy SN sprite to memory
	int test = checkMoveMap();
	if (test == 1) { // keep former spot if there's a wall in the way
		Josh.new_x = Josh.x;
		Josh.new_y = Josh.y;
		redraw_SN();
	} else if ((test - 1 == next_level) && (next_level != 8)) { // Switch to Side Scroller
		Josh.new_x = Josh.x;
		Josh.new_y = Josh.y;
		if ((next_level == 4) || (next_level == 6)) { // the two levels with doors facing up
			Josh.new_dir = ANIM_UP;
		} else { // the rest with doors facing down
			Josh.new_dir = ANIM_DOWN; // Turn Josh around when he comes back out, but don't move him
		}
		ham_DeleteObj(Josh.objNumber);
		fight = 1;
	} else if ((test - 1 == next_level) && (next_level == 8)) { // boss level
		Josh.new_x = Josh.x;
		Josh.new_y = Josh.y;
		Josh.new_dir = ANIM_UP;
		ham_DeleteObj(Josh.objNumber);
		fight = 1;
	} else { // actually move; test=0
		Josh.x = Josh.new_x;
		Josh.y = Josh.new_y;
		redraw_SN();
	}
}

/*********************************************************************************
 * Server Ninja sprite control under overhead map mode
 ********************************************************************************/
void query_keys() {
	if ((living == 0) || (won == 1) || (fight == 1) || (timeflag == 1)) {
		return;
	} else if (F_CTRLINPUT_A_PRESSED) { // user pushes "A" button
	} else if (F_CTRLINPUT_B_PRESSED) { //user pushes "B" button
	} else if (F_CTRLINPUT_L_PRESSED) { //user pushes "L" button
	} else if (F_CTRLINPUT_R_PRESSED) { //user pushes "R" button
	} else if (F_CTRLINPUT_UP_PRESSED && !F_CTRLINPUT_RIGHT_PRESSED && !F_CTRLINPUT_LEFT_PRESSED) {
		// user pushes "UP" only
		Josh.new_y = Josh.y - 1;
		Josh.new_x = Josh.x;
		Josh.new_dir = ANIM_UP;
		Josh.mvt = 1;
		return;
	} else if (F_CTRLINPUT_DOWN_PRESSED && !F_CTRLINPUT_RIGHT_PRESSED && !F_CTRLINPUT_LEFT_PRESSED) {
		// user pushes "DOWN" only
		Josh.new_y = Josh.y + 1;
		Josh.new_x = Josh.x;
		Josh.new_dir = ANIM_DOWN;
		Josh.mvt = 1;
		return;
	} else if (F_CTRLINPUT_LEFT_PRESSED && !F_CTRLINPUT_UP_PRESSED && !F_CTRLINPUT_DOWN_PRESSED) {
		// user pushes "LEFT" only
		Josh.new_y = Josh.y;
		Josh.new_x = Josh.x - 1;
		Josh.new_dir = ANIM_LEFT;
		Josh.mvt = 1;
		return;
	} else if (F_CTRLINPUT_RIGHT_PRESSED && !F_CTRLINPUT_UP_PRESSED && !F_CTRLINPUT_DOWN_PRESSED) {
		// user pushes "RIGHT" only
		Josh.new_y = Josh.y;
		Josh.new_x = Josh.x + 1;
		Josh.new_dir = ANIM_RIGHT;
		Josh.mvt = 1;
		return;
	}
	Josh.mvt = 0;
}

/*********************************************************************************
 * Next Level Mark Explamation Point as shown under overhead map mode
 ********************************************************************************/
void next_level_marker() {
	switch (next_level) {
	case 1:
		nextlevelmarkerObj1 = ham_CreateObj((void *)&exclamationData[0],0,1,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,7*16,5*16);
		break;
	case 2:
		nextlevelmarkerObj1 = ham_CreateObj((void *)&exclamationData[0],0,1,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,10*16,5*16);
		break;
	case 3:
		nextlevelmarkerObj1 = ham_CreateObj((void *)&exclamationData[0],0,1,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,4*16,2*16);
		break;
	case 4:
		nextlevelmarkerObj1 = ham_CreateObj((void *)&exclamationData[0],0,1,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,6*16,7*16);
		break;
	case 5:
		nextlevelmarkerObj1 = ham_CreateObj((void *)&exclamationData[0],0,1,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,7*16,2*16);
		break;
	case 6:
		nextlevelmarkerObj1 = ham_CreateObj((void *)&exclamationData[0],0,1,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,9*16,7*16);
		break;
	case 7:
		nextlevelmarkerObj1 = ham_CreateObj((void *)&exclamationData[0],0,1,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,10*16,2*16);
		break;
	case 8:
		nextlevelmarkerObj1 = ham_CreateObj((void *)&exclamationData[0],0,1,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,2*16,6*16);
		nextlevelmarkerObj2 = ham_CreateObj((void *)&exclamationData[0],0,1,OBJ_MODE_NORMAL,1,0,0,0,0,1,0,3*16,6*16);
		break;
	}
}

/*********************************************************************************
 * Redraws The server ninja sprite
 ********************************************************************************/
void redraw_SN() {
	// Set the new SN coordinates
	ham_SetObjX(Josh.objNumber, Josh.x);
	ham_SetObjY(Josh.objNumber, Josh.y);

	if ((Josh.mvt == 0)||(Josh.new_dir != Josh.dir)) {
		// Josh isn't moving
		Josh.framecnt = 0;
		Josh.animcnt = 0;
	} else {
		if ((Josh.framecnt ++) >= 10) {
			Josh.framecnt = 0;
			Josh.animcnt = (Josh.animcnt+1)%4;
		}
	}

	array_spot = (1024 * Josh.dir) + (256 * Josh.animcnt);
	// Redisplay Josh
	if (bandanna_color == RED_BANDANNA) {
		ham_UpdateObjGfx(Josh.objNumber,(void *)&sprite_SNData[array_spot]);
	} else if (bandanna_color == BLACK_BANDANNA) {
		ham_UpdateObjGfx(Josh.objNumber,(void *)&sprite_SN2Data[array_spot]);
	} else {	// bandanna_color == BLUE_BANDANNA
		ham_UpdateObjGfx(Josh.objNumber,(void *)&sprite_SN3Data[array_spot]);
	}
	Josh.dir = Josh.new_dir;
	ham_SetObjX(timerObj, (int)(7.5*16));
	ham_SetObjY(timerObj, 0);
	if ((int)ceil(30-30*s_tim0/100) <= 29) {
		ham_UpdateObjGfx(timerObj,(void *)&office_healthData[0+((int)ceil(30-30*s_tim0/100))*128]);
	} else {
		ham_UpdateObjGfx(timerObj,(void *)&office_healthData[29*128]);
	}
}

/*********************************************************************************
 * Check to see if the map needs to be moved
 ********************************************************************************/
int checkMoveMap() {
	switch (Josh.new_dir) {
	case ANIM_UP:
		if (Map[(Josh.new_y + Josh.offsetu)/16][(Josh.new_x + Josh.offsetl)/16] == 1) return 1;
		else return (Map[(Josh.new_y + Josh.offsetu)/16][(Josh.new_x + Josh.offsetr)/16]);
	case ANIM_DOWN:
		if (Map[(Josh.new_y + Josh.offsetd)/16][(Josh.new_x + Josh.offsetl)/16] == 1) return 1;
		else return (Map[(Josh.new_y + Josh.offsetd)/16][(Josh.new_x + Josh.offsetr)/16]);
	case ANIM_LEFT:
		if (Map[(Josh.new_y + Josh.offsetu)/16][(Josh.new_x + Josh.offsetl)/16] == 1) return 1;
		else return (Map[(Josh.new_y + Josh.offsetd)/16][(Josh.new_x + Josh.offsetl)/16]);
	case ANIM_RIGHT:
		if (Map[(Josh.new_y + Josh.offsetu)/16][(Josh.new_x + Josh.offsetr)/16] == 1) return 1;
		else return (Map[(Josh.new_y + Josh.offsetd)/16][(Josh.new_x + Josh.offsetr)/16]);
	default:
		return 0;
	}
}

/****************************************************************
 * Interrupt Function for Side Scroller Map
 ***************************************************************/
void ssvblFunc() {
	ham_CopyObjToOAM(); // copy SN sprite to memory
	int test = sscheckMoveMap();
	if (test == 1) { // keep former spot if there's a wall in the way
		SSJosh.new_x = SSJosh.x;
		SSJosh.new_y = SSJosh.y;
	} else { // actually move
		SSJosh.x = SSJosh.new_x;
		SSJosh.y = SSJosh.new_y;
	}
	redraw_ssSN();
}

/*********************************************************************************
 * Redraws Side Scroller Sprites
 ********************************************************************************/
void redraw_ssSN() {
	int test = SSMap[0][(int)floor((SSJosh.new_x + SSJosh.offsetl)/16)];
	// Set the new SN coordinates
	ham_SetObjX(SSJosh.objNumber2, SSJosh.x);
	ham_SetObjY(SSJosh.objNumber2, SSJosh.y);
	ham_SetObjX(SSJosh.objNumber3, SSJosh.x);
	ham_SetObjY(SSJosh.objNumber3, (SSJosh.y+64));

	if ((SSJosh.mvt == 0)||(SSJosh.new_dir != SSJosh.dir)) {	// Josh isn't moving
		SSJosh.framecnt = 0;
		SSJosh.animcnt = 0;
	} else {
		if ((SSJosh.framecnt ++) >= 10) {
			SSJosh.framecnt = 0;
			SSJosh.animcnt = (SSJosh.animcnt+1)%2;
		}
	}

	if (SSJosh.attackA == 1) {
		attacked_last_roundA = 1;
		attacked_last_roundB = 0;
		SSJosh.animcnt = 0;
		array_spot = (SSJosh.A_weapon * 3072);
	} else if (SSJosh.attackB == 1) {
		attacked_last_roundA = 0;
		attacked_last_roundB = 1;
		SSJosh.animcnt = 0;
		array_spot = (SSJosh.B_weapon * 3072);
	} else if (attacked_last_roundA == 1) {	// to get the second frame of animation in
		attacked_last_roundA = 0;
		attacked_last_roundB = 0;
		SSJosh.animcnt = 1;
		do_damage(SSJosh.A_weapon);
		array_spot = (1536 * SSJosh.animcnt) + (SSJosh.A_weapon * 3072);
	} else if (attacked_last_roundB == 1) {
		attacked_last_roundA = 0;
		attacked_last_roundB = 0;
		SSJosh.animcnt = 1;
		if (test == 2) {	// within melee range
			do_damage(SSJosh.B_weapon);
		}
		array_spot = (1536 * SSJosh.animcnt) + (SSJosh.B_weapon * 3072);
	} else {
		array_spot = (1536 * SSJosh.animcnt);
	}

	if (SSJosh.swapL == 1) {
		used_L_last_round = 1;
		SSJosh.swapL = 0;
	} else if (SSJosh.swapR == 1) {
		used_R_last_round = 1;
		SSJosh.swapR = 0;
	} else if (used_L_last_round == 1) {
		used_L_last_round = 0;
		SSJosh.A_weapon = (SSJosh.A_weapon) % 4 + 1;
	} else if (used_R_last_round == 1) {
		used_R_last_round = 0;
		SSJosh.B_weapon = (SSJosh.B_weapon-4) % 3 + 5;
	}

	// Redisplay Josh
	if (bandanna_color == RED_BANDANNA) {
		ham_UpdateObjGfx(SSJosh.objNumber2,(void *)&SS_SNData[array_spot]);
		ham_UpdateObjGfx(SSJosh.objNumber3,(void *)&SS_SNData[array_spot+1024]);
	} else if (bandanna_color == BLACK_BANDANNA) {
		ham_UpdateObjGfx(SSJosh.objNumber2,(void *)&SS_SN2Data[array_spot]);
		ham_UpdateObjGfx(SSJosh.objNumber3,(void *)&SS_SN2Data[array_spot+1024]);
	} else {	// bandanna_color == BLUE_BANDANNA
		ham_UpdateObjGfx(SSJosh.objNumber2,(void *)&SS_SN3Data[array_spot]);
		ham_UpdateObjGfx(SSJosh.objNumber3,(void *)&SS_SN3Data[array_spot+1024]);
	}
	post_weapons();
	SSJosh.dir = SSJosh.new_dir;
	ham_SetObjX(timerObj, (int)(7.5*16));
	ham_SetObjY(timerObj, 0);
	if ((int)ceil(30-30*s_tim0/100) <= 29) {
		ham_UpdateObjGfx(timerObj,(void *)&office_healthData[((int)ceil(30-30*s_tim0/100))*128]);
	} else {
		ham_UpdateObjGfx(timerObj,(void *)&office_healthData[29*128]);
	}
}

/*********************************************************************************
 * Weapon Sprites intialization
 ********************************************************************************/
void post_weapons() {
	ham_SetObjX(officeObj, (int)(6.5*16));
	ham_SetObjY(officeObj, 9*16);
	ham_SetObjX(SSJosh.AObj, 0);
	ham_SetObjY(SSJosh.AObj, 9*16);
	ham_SetObjX(SSJosh.BObj, 14*16);
	ham_SetObjY(SSJosh.BObj, 9*16);
	if (enemy_health <= 0) {
		enemy_dead = 1;
	} else if (((int)ceil(30-30.0*enemy_health/(90+(next_level*10)))) > 29) {
		ham_UpdateObjGfx(officeObj,(void *)&office_healthData[29*128]);
	} else {
		ham_UpdateObjGfx(officeObj,(void *)&office_healthData[((int)ceil(30-30.0*enemy_health/(90+(next_level*10))))*128]);
	}
	ham_UpdateObjGfx(SSJosh.AObj,(void *)&A_weaponsData[0+(SSJosh.A_weapon-1)*32]);
	ham_UpdateObjGfx(SSJosh.BObj,(void *)&B_weaponsData[0+(SSJosh.B_weapon-5)*32]);
}

/*********************************************************************************
 * Checks to see if the map needs to move in SS mode
 ********************************************************************************/
int sscheckMoveMap() {
	switch (SSJosh.new_dir) {
	case ANIM_LEFT_SS:
		return (SSMap[0][(int)floor((SSJosh.new_x + SSJosh.offsetl)/16)]);
	case ANIM_RIGHT_SS:
		return (SSMap[0][(int)ceil((SSJosh.new_x + SSJosh.offsetr)/16)]);
	default:
		return 0;
	}
}

/*********************************************************************************
 * Check to see of any keys have been pressed in Side Scroll mode then
 * acts accordingly.
 ********************************************************************************/
void query_keys_ss() {
	if (F_CTRLINPUT_A_PRESSED) { // user pushes "A" button
		SSJosh.mvt = 0;
		SSJosh.attackA = 1;
		SSJosh.attackB = 0;
		return;
	} else if (F_CTRLINPUT_B_PRESSED) { //user pushes "B" button
		SSJosh.mvt = 0;
		SSJosh.attackA = 0;
		SSJosh.attackB = 1;
		return;
	} else if (F_CTRLINPUT_L_PRESSED) { //user pushes "L" button
		SSJosh.swapL = 1;
	} else if (F_CTRLINPUT_R_PRESSED) { //user pushes "R" button
		SSJosh.swapR = 1;
	} else if (F_CTRLINPUT_LEFT_PRESSED) {
		// user pushes "LEFT" with or without accidentally holding onto UP or DOWN
		SSJosh.new_y = SSJosh.y;
		SSJosh.new_x = SSJosh.x - 1;
		SSJosh.new_dir = ANIM_LEFT_SS;
		SSJosh.mvt = 1;
		SSJosh.attackA = 0;
		SSJosh.attackB = 0;
		return;
	} else if (F_CTRLINPUT_RIGHT_PRESSED) {
		// user pushes "RIGHT" with or without accidentally holding onto UP or DOWN
		SSJosh.new_y = SSJosh.y;
		SSJosh.new_x = SSJosh.x + 1;
		SSJosh.new_dir = ANIM_RIGHT_SS;
		SSJosh.mvt = 1;
		SSJosh.attackA = 0;
		SSJosh.attackB = 0;
		return;
	}
	SSJosh.mvt = 0;
	SSJosh.attackA = 0;
	SSJosh.attackB = 0;
	if (enemy_health <= 0) {
		enemy_dead = 1;
	}
}

/*********************************************************************************
 * Sets up weapon damage and subtracks health from opponents
 ********************************************************************************/
void do_damage(u8 weapon) {

	switch (weapon) {
	case 1:	// Witty comeback
		if (next_level == 3) {	// Double damage
			enemy_health -= 10;
		} else if (next_level == 5) { // Half damage
			enemy_health -= 2;
		} else {	// Everyone else
			enemy_health -= 5;
		}
		break;
	case 2:	// CDs
		if (next_level == 4) {	// Double damage
			enemy_health -= 10;
		} else if (next_level == 6) { // Half damage
			enemy_health -= 2;
		} else {	// Everyone else
			enemy_health -= 5;
		}
		break;
	case 3:	// Squirt Gun
		if (next_level == 1) {	// Double damage
			enemy_health -= 10;
		} else if (next_level == 3) { // Half damage
			enemy_health -= 2;
		} else {	// Everyone else
			enemy_health -= 5;
		}
		break;
	case 4:	// Nerf Football
		if (next_level == 2) {	// Double damage
			enemy_health -= 10;
		} else if (next_level == 1) { // Half damage
			enemy_health -= 2;
		} else {	// Everyone else
			enemy_health -= 5;
		}
		break;
	case 5:	// 5' Cat 5 cable
		if (next_level == 5) {	// Double damage
			enemy_health -= 10;
		} else if (next_level == 4) { // Half damage
			enemy_health -= 2;
		} else {	// Everyone else
			enemy_health -= 5;
		}
		break;
	case 6:	// Lan meter
		if (next_level == 6) {	// Double damage
			enemy_health -= 10;
		} else if (next_level == 7) { // Half damage
			enemy_health -= 2;
		} else {	// Everyone else
			enemy_health -= 5;
		}
		break;
	case 7:	// Virus-laden diskette
		if (next_level == 7) {	// Double damage
			enemy_health -= 10;
		} else if (next_level == 2) { // Half damage
			enemy_health -= 2;
		} else {	// Everyone else
			enemy_health -= 5;
		}
		break;
	default: // if this gets called with a different number, do nothing
		break;
	}
	if (enemy_health <= 0) {
		enemy_dead = 1;
	}
}

/*********************************************************************************
 * Inializations Server Ninja in Side Scroll Mode
 ********************************************************************************/
void SNinit_SS() {

	ham_LoadObjPal(&sprite_SNPalette, 256);
	SSJosh.dir = ANIM_RIGHT_SS;
	SSJosh.framecnt = 0;
	SSJosh.animcnt = 0;
	SSJosh.x = 32;
	SSJosh.y = 48;
	SSJosh.new_x = 32;
	SSJosh.new_y = 48;
	SSJosh.offsetl = 4;
	SSJosh.offsetu = 0;
	SSJosh.offsetd = 0;
	SSJosh.offsetr = 12;
	SSJosh.mvt = 0;
	SSJosh.A_weapon = WITTY_COMEBACK_W;
	SSJosh.B_weapon = FIVE_FT_CABLE_W;
	SSJosh.attackA = 0;
	SSJosh.attackB = 0;
}

/****************************************************************
 * Interrupt Function for Boss Battle map mode
 ***************************************************************/
void bbvblFunc() {
	ham_CopyObjToOAM(); // copy SN sprite to memory
	redraw_bb();
}

/*********************************************************************************
 * Queries the keys pressed druing boss battle map mode
 ********************************************************************************/
void query_keys_bb() {
	if (F_CTRLINPUT_A_PRESSED) { // user pushes "A" button
		picked = 1;
		return;
	} else if (F_CTRLINPUT_UP_PRESSED) {
		// user pushes "UP" with or without accidentally holding onto RIGHT or LEFT
		newselection = (selection + 2) % 3;
		changed = 1;
		return;
	} else if (F_CTRLINPUT_DOWN_PRESSED) {
		// user pushes "DOWN" with or without accidentally holding onto RIGHT or LEFT
		newselection = (selection + 1) % 3;
		changed = 1;
		return;
	}
	picked = 0;
}

/*********************************************************************************
 * redraws Boss battle mode Sprites
 ********************************************************************************/
void redraw_bb() {
	// Set the new object coordinates
	ham_SetObjX(boss_balloon, 156);
	ham_SetObjY(boss_balloon, 0);
	ham_SetObjX(choicewin1, 24);
	ham_SetObjY(choicewin1, 127);
	ham_SetObjX(choicewin2, 88);
	ham_SetObjY(choicewin2, 127);
	ham_SetObjX(choicewin3, 152);
	ham_SetObjY(choicewin3, 127);

	if (changed == 1) {
		made_selection_last_round = 1;
		changed = 0;
	} else if (made_selection_last_round == 1) {
		selection = newselection;
		made_selection_last_round = 0;
	}

	ham_SetObjX(selectObj, 24);
	ham_SetObjY(selectObj, 129 + (selection * 9));

	if (picked == 1) {
		picked_last_round = 1;
		picked = 0;
	} else if (picked_last_round == 1) {
		update_bb_arrays();
		picked_last_round = 0;
		selection = 0;
		newselection = 0;
	}

	// Redisplay everything
	ham_UpdateObjGfx(boss_balloon,(void *)&boss_talkData[boss_spot * 2048]);
	ham_UpdateObjGfx(choicewin1,(void *)&full_responseData[(response_spot * 3072)]);
	ham_UpdateObjGfx(choicewin2,(void *)&full_responseData[(response_spot * 3072) + 1024]);
	ham_UpdateObjGfx(choicewin3,(void *)&full_responseData[(response_spot * 3072) + 2048]);
	ham_UpdateObjGfx(selectObj,(void *)&AData[0]);
}

/*********************************************************************************
 * Updates responses in boss battle map mode
 ********************************************************************************/
void update_bb_arrays() {
	
	switch (boss_spot) {
	case 0:	// Where have all my help gone?
		if (selection == 0) {
			boss_spot = 1;
			response_spot = 1;
		} else if (selection == 1) {
			boss_spot = 2;
			response_spot = 2;
		} else {
			boss_spot = 3;
			response_spot = 3;
		}
		break;
	case 1:	// That might be  true, but you don't have the power to do that
		if (selection == 0) {
			boss_spot = 13;		// resignation on desk
			response_spot = 12;	// Press A to continue. Died
			ham_DeleteObj(selectObj);
		} else if (selection == 1) {
			boss_spot = 4;		// the network is down again?
			response_spot = 4;	// I don't see how these people past college
		} else {
			boss_spot = 12;		// I don't like your attitude
			response_spot = 12;	// Press A to continue. Died
			ham_DeleteObj(selectObj);
		}
		break;
	case 2:	// that's not very funny Josh
		if (selection == 0) {
			won = 1;			// Kill the boss
		} else if (selection == 1) {
			boss_spot = 5;		// you don't have that power
			response_spot = 1;	// back to first column
		} else {
			boss_spot = 6;		// that's very considerate of you
			response_spot = 5;	// that's me .... mister considerate
		}
		break;
	case 3:	// You can dispense with the ass-kissin'
		if (selection == 0) {
			boss_spot = 7;		// we'll not have that kind of language here
			response_spot = 6;	// what fucking language?
		} else if (selection == 1) {
			boss_spot = 8;		// Sure you didn't.  You're fired
			response_spot = 12;	// Press A to continue.  Died
			ham_DeleteObj(selectObj);
		} else {
			boss_spot = 9;		// I have a feeling you know exactly why she was crying
			response_spot = 7;	// what makes you say that, sir?
		}
		break;
	case 4:	// The network is down again?
		if (selection == 0) {
			boss_spot = 10;		// Most are high school drop outs that make more than you
			response_spot = 8;	// I can't stand it.
		} else if (selection == 1) {
			boss_spot = 2;		// I don't like your attitude
			response_spot = 12;	// Press A to continue.  Died
			ham_DeleteObj(selectObj);
		} else {
			boss_spot = 11;		// Play solitare and tell people what to do.
			response_spot = 9;	// Lucky.  When you gonna retire?
		}
		break;
	case 5:	// you don't have that power
		if (selection == 0) {
			boss_spot = 13;		// resignation on desk
			response_spot = 12;	// Press A to continue. Died
			ham_DeleteObj(selectObj);
		} else if (selection == 1) {
			boss_spot = 4;		// the network is down again?
			response_spot = 4;	// I don't see how these people past college
		} else {
			boss_spot = 12;		// I don't like your attitude
			response_spot = 12;	// Press A to continue. Died
			ham_DeleteObj(selectObj);
		}
		break;
	case 6:	// umm .... very considerate of you
		if (selection == 0) {
			boss_spot = 4;		// The network is down again?
			response_spot = 4;	// I don't see how these people past college
		} else if (selection == 1) {
			boss_spot = 12;		// I don't like your attitude
			response_spot = 12;	// Press A to continue. Died
			ham_DeleteObj(selectObj);
		} else {
			boss_spot = 17;		// Fine.  Now get back to work and stop sending my help home.
			response_spot = 12;	// Press A to continue. WON!!!
			ham_DeleteObj(selectObj);
		}
		break;
	case 7:	// we'll not have that kind of language around here, Josh
		if (selection == 0) {
			boss_spot = 12;		// I dont' like your attitude
			response_spot = 12;	// Press A to conitnue.  Died
			ham_DeleteObj(selectObj);
		} else if (selection == 1) {
			boss_spot = 4;		// The network is down again?
			response_spot = 4;	// I don't see how these people past college
		} else {
			boss_spot = 12;		// I don't like your attitude
			response_spot = 12;	// Press A to continue.  died
			ham_DeleteObj(selectObj);
		}
		break;
	case 8:	// Sure you didn't .... you're fired
		living = 0;
		break;
	case 9:	// I have a feeling you know exactly why she was crying
		if (selection == 0) {
			boss_spot = 12;		// I don't like your attitude
			response_spot = 12;	// Press A to continue.  Died
			ham_DeleteObj(selectObj);
		} else if (selection == 1) {
			boss_spot = 1;		// That might be true, but you don't have that power.
			response_spot = 1;	// I gave myself the power
		} else {
			boss_spot = 13;		// Then leave.  I expect your resignation by 5
			response_spot = 12;	// Press A to continue.  Died
			ham_DeleteObj(selectObj);
		}
		break;
	case 10:// Most are just high school drop-outs that make more than you
		if (selection == 0) {
			boss_spot = 13;		// Then leave.  I expect your resignation by 5
			response_spot = 12;	// Press A to continue.  Died.
			ham_DeleteObj(selectObj);
		} else if (selection == 1) {
			boss_spot = 14;		// Absolutely, can't have me getting in the way of progress
			response_spot = 12;	// Press A to continue. WON!!!
			ham_DeleteObj(selectObj);
		} else {
			boss_spot = 12;		// I don't like your attitude
			response_spot = 12;	// Press A to continue.  Died
			ham_DeleteObj(selectObj);
		}
		break;
	case 11:// I play solitare, and tell people what to do
		if (selection == 0) {
			boss_spot = 15;		// Golden parachute
			response_spot = 10;	// eww
		} else if (selection == 1) {
			boss_spot = 12;		// I don't like your attitude
			response_spot = 12;	// Press A to continue.  Died
			ham_DeleteObj(selectObj);
		} else {
			boss_spot = 14;		// Absolutely, can't have me getting in the way of progress
			response_spot = 12;	// Press A to continue.  WON!!!
			ham_DeleteObj(selectObj);
		}
		break;
	case 12:// I don't like your attitude young man, you're fired
		living = 0;
		break;
	case 13:// Then leave, I expect your resignation on my desk by 5
		living = 0;
		break;
	case 14:// Absolutely, can't have me getting in the way of progress
		won = 1;
		break;
	case 15:// As soon as I get the option for the golden parachute
		if (selection == 0) {
			boss_spot = 16;		// Nice.  You kiss your mother with that mouth?
			response_spot = 11;	// I kiss YOUR mother with this mouth
		} else if (selection == 1) {
			boss_spot = 12;		// I don't like your attitude
			response_spot = 12;	// Press A to continue.  Died
			ham_DeleteObj(selectObj);
		} else {
			boss_spot = 17;		// Fine.  Now get back to work, and stop sending my help home
			response_spot = 12;	// Press A to continue.  WON!!!
			ham_DeleteObj(selectObj);
		}
		break;
	case 16:// Nice, do you kiss your mother with that mouth?
		if (selection == 0) {
			boss_spot = 12;		// I don't like your attitude
			response_spot = 12;	// Press A to continue.  Died
			ham_DeleteObj(selectObj);
		} else if (selection == 1) {
			boss_spot = 12;		// I don't like your attitude
			response_spot = 12;	// Press A to continue.  Died
			ham_DeleteObj(selectObj);
		} else {
			boss_spot = 17;		// Fine.  Now get back to work, and stop sending my help home.
			response_spot = 12;	// Press A to continue.  WON!!
			ham_DeleteObj(selectObj);
		}
		break;
	case 17:// Fine, get back to work, and stop sending my staff home.
		won = 1;
	}
}

/****************************************************************
 * Deletes Sprites from overhead map mode
 ***************************************************************/
void clean_overhead() {
	ham_DeleteObj(Josh.objNumber);
	ham_DeleteObj(nextlevelmarkerObj1);
	if (next_level == 8) {
		ham_DeleteObj(nextlevelmarkerObj2);
	}
	ham_DeleteObj(timerObj);
	ham_DeleteObj(serverObj);
}

/*********************************************************************************
 * Deletes sprites from Side scroller mode
 ********************************************************************************/
void clean_SS() {
	next_level++;
	fight = 0;
	if (s_tim0 <= 90) { // under or equal to 90 means that I can add ten without messing something up
		s_tim0 += 10; // reward for beating the enemy
	} else {
		s_tim0 = 100; // Can't have more than max time
	}
	ham_DeleteObj(SSJosh.objNumber1);
	ham_DeleteObj(SSJosh.objNumber2);
	ham_DeleteObj(SSJosh.objNumber3);
	ham_DeleteObj(officeObj);
	ham_DeleteObj(SSJosh.AObj);
	ham_DeleteObj(SSJosh.BObj);
	ham_DeleteObj(AObj);
	ham_DeleteObj(BObj);
	ham_DeleteObj(enemyObj);
	ham_DeleteObj(timerObj);
	ham_DeleteObj(serverObj);
	ham_DeInitBg(0);
	ham_InitBg(1,1,1,0); // turn back on the overhead map
   	ham_LoadObjPal(&sprite_SNPalette, 256);
	circussound();
	overhead();
}

/*********************************************************************************
 * Deletes sprites from Boss battle map mode
 ********************************************************************************/
void clean_BB() {
	ham_DeleteObj(boss_balloon);
	ham_DeleteObj(choicewin1);
	ham_DeleteObj(choicewin2);
	ham_DeleteObj(choicewin3);
	ham_DeleteObj(selectObj);
	next_level ++;
	fight = 0;
	ham_DeInitBg(0);
	ham_ResetBg();
}